       subroutine mat_set(n, a, nm, mtype)

       implicit double precision(a-h,o-z),integer(i-n)
       real(8)                :: a(1:nm,*)
       real(8), pointer       :: as(:,:)
       integer, pointer       :: iseed(:)

       integer :: SEED_(4)


          if(mtype==0)then
             do i=1,n
                do j=1,n
                   a(j,i)=(n+1-Max(n+1-i,n+1-j))*1.0D+00
                enddo
             enddo
          endif
          if(mtype==1)then
             do i=1,n
                do j=1,n
                   if(i==j)then
                      a(j,i)=-7.2D0
                   else
                      a(j,i)=-3.0D0/(i-j)**2
                   endif
                enddo
             enddo
          endif
          if(mtype==2)then

             allocate (as(1:nm,n))

             CALL RANDOM_SEED( size=i )
             allocate( iseed(i) )
             iseed(1:i) = 1
             CALL RANDOM_SEED( put=iseed )
             deallocate( iseed )

             do i=1,n
                do j=1,n
                   CALL RANDOM_NUMBER(t)
                   as(j,i)=t
                   a (j,i)=t
                enddo
             enddo

             ! A <= A + AS'
             do i=1,n
                do j=1,n
                   a(j,i)=a(j,i)+as(i,j)
                enddo 
             enddo 

             deallocate( as )

          endif
          if(mtype==3)then
             SEED_(1) = 0
             SEED_(2) = 0
             SEED_(3) = 0
             SEED_(4) = 1
             allocate (as(1:n,n))
             call DLARNV( 1, SEED_, n*n, as )
             do i=1,n
                a(1:n,i)=as(1:n,i)
             enddo
             deallocate( as )
             do i=1,n-1
                a(i+1:n,i)=a(i,i+1:n)
             enddo
          endif

       return
       end

