       subroutine tred1_local_2update(
     &               u_x, nm,
     &               ux, vx,
     &               i_base, i, ix)
       use OMP_LIB
       implicit none
!
       integer, intent(in)    ::  nm
       real(8), intent(inout) ::  u_x(1:nm,*)
       real(8), intent(in)    ::  ux(1:nm,*)
       real(8), intent(in)    ::  vx(1:nm,*)
       integer, intent(in)    ::  i_base, i, ix
!
       integer                ::  k_1
       integer                ::  j, k, l
!
       integer                ::  i_1, i_2, i_3, i_4
       integer                ::  j_1, j_2, j_3, j_4
       integer                ::  l_1, l_2, l_3, l_4
       integer                ::  jj_1, jj_2, jj_3, jj_4
       integer                ::  LX
!
       include 'trd.h'
       include 'param.h'
       include 'CSTAB.h'
!
          if ( i - i_base <= 1 ) return
!
          i_2 = i_base+1
          i_3 = i-1
!
          L   = ix - 1

          jj_1 = omp_get_num_threads()
          jj_2 = omp_get_thread_num()
          jj_3 = MIN(jj_1-1, 1)
          jj_1 = jj_1 - jj_3; jj_2 = jj_2 - jj_3

          do j_1=1+64*jj_2,L,64*jj_1; j_2=MIN(64,L-j_1+1)

             call dger( j_2, i_3-i_2+1,
     &                 -1D0, ux(j_1, 1), 1, vx(i_2, 1), 1,
     &                       u_x(j_1, i_2-i_base), nm )
             call dger( j_2, i_3-i_2+1,
     &                 -1D0, vx(j_1 ,1), 1, ux(i_2, 1), 1,
     &                       u_x(j_1, i_2-i_base), nm )

          enddo
!
       return
       end subroutine ! tred1_local_2update

