c======================================================================c
      subroutine tred1_2update(
     &      ar, nm,
     &      ur, vr,
     &      m_size, i_base)
c======================================================================c
!$    use omp_lib
      implicit NONE
c
      real(8), intent(inout) :: ar (nm, *)
      real(8), intent(in)    :: ur (nm, *)
      real(8), intent(in)    :: vr (nm, *)
      integer, intent(in)    :: nm, m_size, i_base
c
      include 'param.h'
c
      include 'trd.h'

      integer ::  m, n
c
      external          :: CUBLAS_DSYR2K
c
c======================================================================c
c
      if ( i_base <= 0 .OR. m_size <= 0 ) return
c
c======================================================================c
c
      call cuda_sync( -1 )

      m  = m_size
      n  = i_base
      call CUBLAS_DSYR2K('U','N',
     &                   n, m,
     &                   M_ONE, devPtr_VX, nm,
     &                          devPtr_UX, nm,
     &                   ONE,   devPtr_A , nm)

      call cuda_sync( 1 )
c
c======================================================================c
c
c-
      return
      end subroutine tred1_2update
c======================================================================c

