      subroutine tred1_load(u_x, nm,
     &              m0, i_base, i_block)
      use OMP_LIB
      implicit NONE

      integer, intent(in)    ::  nm, m0, i_base, i_block
      real(8), intent(out)   ::  u_x(1:nm,*)

      integer                ::  i, j
      integer(8)             ::  idx_A
      integer(8)             ::  i8_
      integer(8)             ::  mlen

      include 'trd.h'
      include 'param.h'
!
! all threads pass
!

      idx_A = int(i_base+1-1,8)*int(nm,8)*8
      mlen = int(nm,8)*int(m0-1,8)+int(i_base+m0,8)
      call cuda_sync( -1 )
      call cuda_get_vector( mlen, eSize, devPtr_A+idx_A, u_x )
      call cuda_sync( 1 )
!
! all threads pass
!
      return
      end subroutine tred1_load

